Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_clock.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_clock.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_clock.cpp	(revision 42)
@@ -13,7 +13,7 @@
 namespace behavioural          {
 
-  string Interface::get_clock (void)
+  Signal * Interface::get_clock (void)
   {
-    string clock = "";
+    Signal * clock = NULL;
     
     if (not _list_signal->empty())
@@ -23,11 +23,11 @@
 	while (i != _list_signal->end())
 	  {
-	    string str = (*i)->get_clock ();
+	    Signal * sig = (*i)->get_clock ();
 
-	    if (str != "")
+	    if (sig != NULL)
 	      {
-		if (clock != "")
+		if (clock != NULL)
 		  throw ErrorMorpheo ("<Interface.get_clock> : find too many clock.");
-		clock = str;
+		clock = sig;
 	      }
 	    ++i;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_comment.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_comment.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_comment.cpp	(revision 42)
@@ -1,2 +1,3 @@
+#ifdef POSITION
 /*
  * $Id$
@@ -22,2 +23,3 @@
 }; // end namespace behavioural          
 }; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_name.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_name.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_name.cpp	(revision 42)
@@ -0,0 +1,23 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Interface.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  string Interface::get_name (void)
+  {
+    log_printf(FUNC,Behavioural,"get_name","Begin");
+    string res = _name;
+    log_printf(FUNC,Behavioural,"get_name","End");
+    return res;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_reset.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_reset.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_reset.cpp	(revision 42)
@@ -0,0 +1,42 @@
+#ifdef VHDL_TESTBENCH
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Interface.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  Signal * Interface::get_reset (void)
+  {
+    Signal * reset = NULL;
+    
+    if (not _list_signal->empty())
+      {
+	list<Signal*>::iterator i = _list_signal->begin();
+	
+	while (i != _list_signal->end())
+	  {
+	    Signal * sig = (*i)->get_reset ();
+
+	    if (sig != NULL)
+	      {
+		if (reset != NULL)
+		  throw ErrorMorpheo ("<Interface.get_reset> : find too many reset.");
+		reset = sig;
+	      }
+	    ++i;
+	  }
+      }
+
+    return reset;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_signal.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_signal.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_get_signal.cpp	(revision 42)
@@ -69,4 +69,9 @@
 #endif
 
+  list<Signal *> * Interface::get_signal_list (void)
+    {
+      return _list_signal;
+    }
+
 }; // end namespace behavioural          
 }; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_interface_map.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_interface_map.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_interface_map.cpp	(revision 42)
@@ -0,0 +1,29 @@
+#ifdef POSITION
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Interface.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  void Interface::interface_map (void * entity,
+				 void * interface)
+  {
+    log_printf(FUNC,Behavioural,"interface_map","Begin");
+
+    _is_map        = true     ;
+    _entity_map    = entity   ;
+    _interface_map = interface;
+
+    log_printf(FUNC,Behavioural,"interface_map","End");
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_port_map.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_port_map.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_port_map.cpp	(revision 42)
@@ -1,3 +1,2 @@
-#ifdef POSITION
 /*
  * $Id$
@@ -13,15 +12,16 @@
 namespace behavioural          {
 
-  void Interface::port_map (void * entity,
-			    void * interface)
-  {
-    log_printf(FUNC,Behavioural,"port_map","Begin");
-    _is_map        = true     ;
-    _entity_map    = entity   ;
-    _interface_map = interface;
-    log_printf(FUNC,Behavioural,"port_map","End");
-  };
+//   void Interface::port_map (void * entity,
+// 			    void * interface)
+//   {
+//     log_printf(FUNC,Behavioural,"port_map","Begin");
+// #ifdef POSITION
+//     _is_map        = true     ;
+//     _entity_map    = entity   ;
+//     _interface_map = interface;
+// #endif
+//     log_printf(FUNC,Behavioural,"port_map","End");
+//   };
 
 }; // end namespace behavioural          
 }; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_print.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_print.cpp	(revision 42)
@@ -16,6 +16,10 @@
   {
     log_printf(FUNC,Behavioural,"operator<<","Begin");
+#ifdef POSITION
     output_stream << x._name + "\t"+toString(x._localisation)+"\t"+toString(x._direction) << endl;
     output_stream << x.get_comment() << endl;
+#else
+    output_stream << x._name << endl;
+#endif
     output_stream << x.get_signal () << endl;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_set_comment.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_set_comment.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_set_comment.cpp	(revision 42)
@@ -1,2 +1,3 @@
+#ifdef POSITION
 /*
  * $Id$
@@ -21,2 +22,3 @@
 }; // end namespace behavioural          
 }; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_set_signal.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_set_signal.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_set_signal.cpp	(revision 42)
@@ -20,8 +20,5 @@
     string signame = signal_name(_name, name, direction);
 
-    Signal * sig = new Signal (signame      ,
-			       direction    ,
-			       size         ,
-			       presence_port);
+    Signal * sig = new Signal       (signame, direction, size, presence_port);
 
     _list_signal->push_back (sig);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_body.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_body.cpp	(revision 42)
@@ -14,5 +14,6 @@
 
   void Interface::testbench_body (Vhdl * & vhdl,
-				  string   counter_name)
+				  string   counter_name,
+				  string   reset_name  )
   {
     log_printf(FUNC,Behavioural,"testbench_body","Begin");
@@ -28,5 +29,5 @@
 	while (i != _list_signal->end())
 	  {
-	    (*i)->testbench_body(vhdl, counter_name);
+	    (*i)->testbench_body(vhdl, counter_name, reset_name);
 	    ++i;
 	  }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_test.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_test.cpp	(revision 42)
@@ -14,5 +14,6 @@
 
   string Interface::testbench_test (Vhdl * & vhdl,
-				    string   counter_name)
+				    string   counter_name,
+				    string   reset_name  )
   {
     log_printf(FUNC,Behavioural,"testbench_test","Begin");
@@ -25,5 +26,5 @@
     string test_name_ok = testbench_test_ok     (vhdl);
 
-    vhdl->set_body(test_name + " <= "+test_name_ok+";");
+    vhdl->set_body(test_name + " <= '1' when ("+reset_name+" = '0') else "+test_name_ok+";");
 
     log_printf(FUNC,Behavioural,"testbench_test","End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_test_name.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_test_name.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_test_name.cpp	(revision 42)
@@ -49,4 +49,22 @@
   };
 
+  string Interface::testbench_test_transaction_name (Vhdl * & vhdl)
+  {
+    log_printf(FUNC,Behavioural,"testbench_test_transaction_name","Begin");
+
+    string name;
+
+    name = "interface_";
+    if (_name != "")
+      name += _name + "_";
+    name += "test_transaction";
+
+    vhdl->set_signal(name,1);
+    
+    log_printf(FUNC,Behavioural,"testbench_test_transaction_name","End");
+
+    return name;
+  };
+
 }; // end namespace behavioural          
 }; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_test_ok.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_test_ok.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_testbench_test_ok.cpp	(revision 42)
@@ -20,4 +20,5 @@
 
     vhdl->set_body(test_name + " <= '1' when true");
+
     // set all condition
     if (_list_signal->empty()== false)
@@ -31,5 +32,5 @@
 	  }
       }
-    vhdl->set_body("else '0';");
+    vhdl->set_body("\telse '0';");
     vhdl->set_body("");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_toXML.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_toXML.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interface_toXML.cpp	(revision 42)
@@ -1,2 +1,3 @@
+#ifdef POSITION
 /*
  * $Id$
@@ -43,5 +44,4 @@
   };
 
-#ifdef POSITION
   XML Interface::toXML_mapping (void)
   {
@@ -55,6 +55,6 @@
     xml.singleton_begin ("port_map");
     xml.  attribut      ("name"     ,_name               );
-    xml.  attribut      ("component",(static_cast<Entity    *>(_entity_map   ))->_name);
-    xml.  attribut      ("port"     ,(static_cast<Interface *>(_interface_map))->_name);
+    xml.  attribut      ("component",(static_cast<Entity    *>(_entity_map   ))->get_name());
+    xml.  attribut      ("port"     ,(static_cast<Interface *>(_interface_map))->get_name());
     xml.singleton_end   ();
 
@@ -63,5 +63,5 @@
     return xml;
   };
-#endif
 }; // end namespace behavioural          
 }; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_find_interface.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_find_interface.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_find_interface.cpp	(revision 42)
@@ -15,9 +15,9 @@
     if (_list_interface->empty()== false)
       {
-	list<Interface_fifo*>::iterator i     = _list_interface->begin();
+	list<Interface_fifo*>::iterator i = _list_interface->begin();
 
 	while (i != _list_interface->end())
 	  {
-	    if ((*i)->_name == name)
+	    if ((*i)->get_name() == name)
 	      return (*i);
 	    ++i;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_find_signal.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_find_signal.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_find_signal.cpp	(revision 42)
@@ -0,0 +1,53 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Interfaces.h"
+
+namespace morpheo              {
+namespace behavioural          {
+
+  Signal * Interfaces::find_signal (string name)
+  {
+    if (_list_interface->empty()== false)
+      {
+	list<Interface_fifo*>::iterator i = _list_interface->begin();
+
+	while (i != _list_interface->end())
+	  {
+	    Signal * signal = (*i)->find_signal(name);
+
+	    // Warning : Name of signal is uniq
+	    if (signal != NULL)
+	      return signal;
+
+	    ++i;
+	  }
+      }
+     
+    return NULL;
+  };
+
+  bool Interfaces::find_signal (Signal * signal)
+  {
+    if (_list_interface->empty()== false)
+      {
+	list<Interface_fifo*>::iterator i = _list_interface->begin();
+
+	while (i != _list_interface->end())
+	  {
+	    if ((*i)->find_signal(signal) == true)
+	      return true;
+
+	    ++i;
+	  }
+      }
+     
+    return false;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_get_clock.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_get_clock.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_get_clock.cpp	(revision 42)
@@ -13,21 +13,21 @@
 namespace behavioural          {
   
-  string Interfaces::get_clock (void)
+  Signal * Interfaces::get_clock (void)
   {
-    string clock = "";
+    Signal * clock = NULL;
     
     if (not _list_interface->empty())
       {
-	list<Interface_fifo*>::iterator i     = _list_interface->begin();
+	list<Interface_fifo*>::iterator i = _list_interface->begin();
 	
 	while (i != _list_interface->end())
 	  {
-	    string str = (*i)->get_clock ();
+	    Signal * sig = (*i)->get_clock ();
 
-	    if (str != "")
+	    if (sig != NULL)
 	      {
-		if (clock != "")
+		if (clock != NULL)
 		  throw ErrorMorpheo ("<Interfaces.get_clock> : find too many clock.");
-		clock = str;
+		clock = sig;
 	      }
 	    ++i;
@@ -35,5 +35,5 @@
       }
 
-    if (clock == "")
+    if (clock == NULL)
       throw ErrorMorpheo ("<Interfaces.get_clock> : no clock find.");
     
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_get_interface.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_get_interface.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_get_interface.cpp	(revision 42)
@@ -47,4 +47,9 @@
   };
 
+  list<Interface_fifo*>* Interfaces::get_interface_list (void)
+  {
+    return _list_interface;
+  };
+
 }; // end namespace behavioural          
 }; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_get_reset.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_get_reset.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_get_reset.cpp	(revision 42)
@@ -0,0 +1,45 @@
+#ifdef VHDL_TESTBENCH
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Interfaces.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+  
+  Signal * Interfaces::get_reset (void)
+  {
+    Signal * reset = NULL;
+    
+    if (not _list_interface->empty())
+      {
+	list<Interface_fifo*>::iterator i     = _list_interface->begin();
+	
+	while (i != _list_interface->end())
+	  {
+	    Signal * sig = (*i)->get_reset ();
+
+	    if (sig != NULL)
+	      {
+		if (reset != NULL)
+		  throw ErrorMorpheo ("<Interfaces.get_reset> : find too many reset.");
+		reset = sig;
+	      }
+	    ++i;
+	  }
+      }
+
+    if (reset == NULL)
+      throw ErrorMorpheo ("<Interfaces.get_reset> : no reset find.");
+    
+    return reset;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_set_interface.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_set_interface.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_set_interface.cpp	(revision 42)
@@ -11,9 +11,17 @@
 namespace behavioural          {
 
-  Interface_fifo * Interfaces::set_interface (string         name        ,
-					 direction_t    direction   ,
-					 localisation_t localisation)
+  Interface_fifo * Interfaces::set_interface (string         name        
+#ifdef POSITION
+					      ,direction_t    direction   
+					      ,localisation_t localisation
+#endif
+					      )
   {
-    Interface_fifo * interface = new Interface_fifo (name, direction, localisation);
+    Interface_fifo * interface = new Interface_fifo (name
+#ifdef POSITION
+						     ,direction
+						     ,localisation
+#endif
+						     );
     
     _list_interface->push_back (interface);
@@ -22,4 +30,5 @@
   };
 
+#ifdef POSITION
   Interface_fifo * Interfaces::set_interface (string         name        ,
 					 direction_t    direction   ,
@@ -33,5 +42,5 @@
     return interface;
   };
-
+#endif
 
 }; // end namespace behavioural          
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_testbench_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_testbench_body.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_testbench_body.cpp	(revision 42)
@@ -14,5 +14,6 @@
 
   string Interfaces::testbench_body (Vhdl * & vhdl,
-				   string   counter_name)
+				     string   counter_name,
+				     string   reset_name  )
   {
     log_printf(FUNC,Behavioural,"testbench_body","Begin");
@@ -28,6 +29,6 @@
 	while (i != _list_interface->end())
 	  {
-	    (*i)->testbench_body(vhdl, counter_name);
-	    string str = (*i)->testbench_test(vhdl, counter_name);
+	    (*i)->testbench_body(vhdl, counter_name, reset_name);
+	    string str = (*i)->testbench_test(vhdl, counter_name, reset_name);
 
 	    test += " and "+str;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_testbench_generate_file.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_testbench_generate_file.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Interfaces_testbench_generate_file.cpp	(revision 42)
@@ -19,14 +19,18 @@
     Vhdl   * vhdl        = new Vhdl(_name+"_Testbench");
     string   counter     = "counter";
-    string   clock       = this->get_clock();
+    Signal * clock       = this->get_clock();
+    Signal * reset       = this->get_reset();
+    string   clock_name  = clock->get_name();
+    string   reset_name  = reset->get_name();
     uint32_t cycle       = this->get_cycle();
 
-    vhdl      ->set_signal    (counter, "natural", "0");
-    vhdl      ->set_signal    (clock  , 1        , 0); // modif Signal_set_signal
+    vhdl->set_signal    (clock_name, 1, 0);
+    vhdl->set_signal    (reset_name, 1, 0);
+    vhdl->set_signal    (counter, "natural");
     this->set_signal    (vhdl);
 
     vhdl->set_body("");
     vhdl->set_body("------------------------------------------------------");
-    vhdl->set_body("-- Component");
+    vhdl->set_body("-- Component - Intanciation");
     vhdl->set_body("------------------------------------------------------");
     vhdl->set_body("");
@@ -54,30 +58,49 @@
     delete list_signal;
 
-    vhdl->set_body("");
-    vhdl->set_body("------------------------------------------------------");
-    vhdl->set_body("-- Port's affectation");
-    vhdl->set_body("------------------------------------------------------");
-    vhdl->set_body("");
-    string test_name = this->testbench_body(vhdl,counter);
+    string test_name = this->testbench_body(vhdl,counter, reset_name);
 
     vhdl->set_body("");
     vhdl->set_body("------------------------------------------------------");
-    vhdl->set_body("-- process clock");
+    vhdl->set_body("-- reset");
     vhdl->set_body("------------------------------------------------------");
     vhdl->set_body("");
-    vhdl->set_body(clock+" <= not "+clock+" after 50 ns;");
+    vhdl->set_body("-- if the systemC simulate have multiple reset, we make the last");
+    vhdl->set_body(reset_name+" <= '1' after 150 ns;");    
+
     vhdl->set_body("");
-    vhdl->set_body("process ("+clock+")");
+    vhdl->set_body("------------------------------------------------------");
+    vhdl->set_body("-- process clock_name");
+    vhdl->set_body("------------------------------------------------------");
+    vhdl->set_body("");
+    vhdl->set_body(clock_name+" <= not "+clock_name+" after 50 ns;");
+    vhdl->set_body("");
+    vhdl->set_body("process ("+clock_name+")");
     vhdl->set_body("begin");
-    vhdl->set_body("\tif "+clock+"'event and "+clock+" = '1' then");
-    vhdl->set_body("\t\t"+counter+" <= "+counter+"+1;");
+    vhdl->set_body("\tif ("+clock_name+"'event and "+clock_name+" = '1') then");
     vhdl->set_body("");
-    vhdl->set_body("\t\tassert     ("+test_name+" = '1') report \"Test KO\" severity FAILURE;");
-    vhdl->set_body("\t\tassert not ("+counter+" = "+toString(cycle)+") report \"Test OK\" severity FAILURE;");
+    vhdl->set_body("\t\tif ("+reset_name+" = '0') then");
     vhdl->set_body("");
+    vhdl->set_body("\t\t\t"+counter+" <= "+toString(reset->get_reset_cycle(true))+";");
+    vhdl->set_body("");
+    vhdl->set_body("\t\telse");
+    vhdl->set_body("");
+    vhdl->set_body("\t\t\t"+counter+" <= "+counter+"+1;");
+    vhdl->set_body("");
+    vhdl->set_body("\t\t\tassert not ("+counter+" = "+toString(cycle)+") report \"Test OK\" severity FAILURE;");
+    vhdl->set_body("\t\t\tassert not ("+test_name+" = '0') report \"Test KO\" severity FAILURE;");
+
+#ifdef VHDL_TESTBENCH_ASSERT
+    vhdl->set_body("\t\t\t-- Assert ...");
+    for (uint32_t cpt=0; cpt<=cycle; cpt++)
+      vhdl->set_body("\t\t\tassert not ("+counter+" = "+toString(cpt)+") report \"===== Test number "+toString(cpt)+" =====\" severity NOTE;");
+#endif
+
+    vhdl->set_body("");
+    vhdl->set_body("\t\tend if;");
     vhdl->set_body("\tend if;");
     vhdl->set_body("end process;");
 
-    vhdl->generate_file();
+
+    vhdl->generate_file(false,true);
 
     delete vhdl;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal.cpp	(revision 42)
@@ -18,11 +18,15 @@
     _direction     (direction    ),
     _size          (size         ),
-    _presence_port (presence_port)
+    _presence_port ((direction==INTERNAL)?PORT_VHDL_NO_TESTBENCH_NO:presence_port)
   {
     log_printf(FUNC,Behavioural,"Signal","Begin");
+    _is_allocate   = false;
+    _is_map        = false;
+    _signal        = NULL;
+    _sc_signal     = NULL;
+    _sc_signal_map = NULL;
+    _type_info     = UNKNOW;
 #ifdef VHDL_TESTBENCH
-    _signal     = NULL;
-    _type_info  = UNKNOW;
-    _list_value = new list<string>;
+    _list_value    = new list<string>;
 #endif
     log_printf(FUNC,Behavioural,"Signal","End");
@@ -36,7 +40,10 @@
   {
     log_printf(FUNC,Behavioural,"Signal (copy)","Begin");
+    _is_allocate= signal._is_allocate;
+    _is_map     = signal._is_map    ;
+    _sc_signal     = signal._sc_signal    ;
+    _sc_signal_map = signal._sc_signal_map;
+    _type_info  = signal._type_info ;
 #ifdef VHDL_TESTBENCH
-    _signal     = signal._signal    ;
-    _type_info  = signal._type_info ;
     _list_value = signal._list_value;
 #endif
@@ -47,4 +54,50 @@
   {
     log_printf(FUNC,Behavioural,"~Signal","Begin");
+
+//     if (_is_allocate == true)
+//       switch (_direction)
+// 	{
+// 	case IN : 
+// 	  {
+// 	    switch (_type_info)
+// 	      {
+// 	      case BOOL     : {delete (static_cast<sc_in  <bool    > *>(_sc_signal)); break;}
+// 	      case UINT8_T  : {delete (static_cast<sc_in  <uint8_t > *>(_sc_signal)); break;}
+// 	      case UINT16_T : {delete (static_cast<sc_in  <uint16_t> *>(_sc_signal)); break;}
+// 	      case UINT32_T : {delete (static_cast<sc_in  <uint32_t> *>(_sc_signal)); break;}
+// 	      case UINT64_T : {delete (static_cast<sc_in  <uint64_t> *>(_sc_signal)); break;}
+// 	      default       : {throw (ErrorMorpheo ("Signal \""+_name+"\" : type unknow.")); break;}
+// 	      }
+// 	    break;
+// 	  }
+// 	case OUT : 
+// 	  {
+// 	    switch (_type_info)
+// 	      {
+// 	      case BOOL     : {delete (static_cast<sc_out <bool    > *>(_sc_signal)); break;}
+// 	      case UINT8_T  : {delete (static_cast<sc_out <uint8_t > *>(_sc_signal)); break;}
+// 	      case UINT16_T : {delete (static_cast<sc_out <uint16_t> *>(_sc_signal)); break;}
+// 	      case UINT32_T : {delete (static_cast<sc_out <uint32_t> *>(_sc_signal)); break;}
+// 	      case UINT64_T : {delete (static_cast<sc_out <uint64_t> *>(_sc_signal)); break;}
+// 	      default       : {throw (ErrorMorpheo ("Signal \""+_name+"\" : type unknow.")); break;}
+// 	      }
+// 	    break;
+// 	  }
+// 	case INTERNAL : 
+// 	  {
+// 	    switch (_type_info)
+// 	      {
+// 	      case BOOL     : {delete (static_cast<sc_sc_signal <bool    > *>(_sc_signal)); break;}
+// 	      case UINT8_T  : {delete (static_cast<sc_sc_signal <uint8_t > *>(_sc_signal)); break;}
+// 	      case UINT16_T : {delete (static_cast<sc_sc_signal <uint16_t> *>(_sc_signal)); break;}
+// 	      case UINT32_T : {delete (static_cast<sc_sc_signal <uint32_t> *>(_sc_signal)); break;}
+// 	      case UINT64_T : {delete (static_cast<sc_sc_signal <uint64_t> *>(_sc_signal)); break;}
+// 	      default       : {throw (ErrorMorpheo ("Signal \""+_name+"\" : type unknow.")); break;}
+// 	      }
+// 	    break;
+// 	  }
+// 	default       : {throw (ErrorMorpheo ("Signal \""+_name+"\" : direction unknow.")); break;}
+// 	}
+
 #ifdef VHDL_TESTBENCH
     delete _list_value;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_clock.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_clock.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_clock.cpp	(revision 42)
@@ -13,11 +13,11 @@
 namespace behavioural          {
 
-  string Signal::get_clock (void)
+  Signal * Signal::get_clock (void)
   {
     if ((_presence_port == CLOCK_VHDL_YES) or
 	(_presence_port == CLOCK_VHDL_NO ))
-      return _name;
+      return this;
     else
-      return "";
+      return NULL;
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_name.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_name.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_name.cpp	(revision 42)
@@ -0,0 +1,20 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Signal.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  string Signal::get_name (void)
+  {
+      return _name;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_name_vhdl.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_name_vhdl.cpp	(revision 41)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_name_vhdl.cpp	(revision 42)
@@ -1,3 +1,3 @@
-#ifdef VHDL_TESTBENCH
+#  ifdef VHDL_TESTBENCH
 /*
  * $Id$
@@ -17,5 +17,6 @@
     if ((_presence_port == PORT_VHDL_YES_TESTBENCH_YES) or
 	(_presence_port == PORT_VHDL_YES_TESTBENCH_NO ) or
-	(_presence_port == CLOCK_VHDL_YES))
+	(_presence_port == CLOCK_VHDL_YES)              or
+	(_presence_port == RESET_VHDL_YES))
       list_signal->push_back(_name);
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_reset.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_reset.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_reset.cpp	(revision 42)
@@ -0,0 +1,31 @@
+#ifdef VHDL_TESTBENCH
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Signal.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  Signal * Signal::get_reset (void)
+  {
+    if ((_presence_port == RESET_VHDL_YES) or
+	(_presence_port == RESET_VHDL_NO ))
+      {
+	if (_size != 1)
+	  throw ErrorMorpheo ("<Signal.get_reset> : size of signal reset is more than one bit.");
+
+	return this;
+      }
+    else
+      return NULL;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_reset_cycle.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_reset_cycle.cpp	(revision 42)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/src/Signal_get_reset_cycle.cpp	(revision 42)
@@ -0,0 +1,43 @@
+#ifdef VHDL_TESTBENCH
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/include/Signal.h"
+
+
+namespace morpheo              {
+namespace behavioural          {
+
+  uint32_t Signal::get_reset_cycle (bool active_low)
+  {
+    uint32_t num = 0;
+    uint32_t cpt = 0;
+    string   cmp = (active_low==true)?"0":"1";
+
+    if ((_presence_port == RESET_VHDL_YES) or
+	(_presence_port == RESET_VHDL_NO ))
+      {
+	if (_list_value->empty()== false)
+	  {
+	    list<string>::iterator i = _list_value->begin();
+	    
+	    while (i != _list_value->end())
+	      {
+		if ((*i) == cmp)
+		  num = cpt;
+		cpt ++;
+		++i;
+	      }
+	  }
+      }
+
+    return num;
+  };
+
+}; // end namespace behavioural          
+}; // end namespace morpheo              
+#endif
